--[[
	Cargo Tab written by Seryn
	version 1.2.2
	based on mdi-targetlist tab system by draugath
--]]

declare("Cargo_tab", {
	version = "1.2.2",
})


local T = {
	Tab = {
		title = "Cargo",
		columns = {
			{
				title = "Index",
				width = 0,
			},
			{
				title = "Item",
				width = 1,
			},
		},
		filters = {
			{
				title = "Cargo",
				pages = {
					{
						title = "Cargo 1",
						fgcolor = "113 227 144 225 *",
						bgcolor = "52 116 235 225 *",
					},	
					{
						title = "Cargo 2",
						fgcolor = "52 192 235 225 *",
						bgcolor = "34 49 163 225 *",
					},
				},
			},
			{
				title = "Features",
			},
			{
				title = "Nav",
			},
		},
		--------------
		

		currentList = {},
		filter_index = -1,
	}
}

Cargo_tab.T = T
T.Tab.cargoList = {}
T.Tab.dropsList = {}
T.Tab.featureList = { 
	{
		"1",
		"\127b07395** Autotarget ON/OFF",
	},
	{
		"2",
		"\127d8808e** Autotarget Distance Check",
	},
	{	
		"3",
		"\127ffa583** Post Target to Group",
	},
	{	
		"4",
		"\127ffc38c** Post Target to Guild",
	},
	{	
		"5",
		"\127ffe5b1** Post Target to active channel",
	},
	{	
		"6",
		"\127fff190** Plot route home",
	},
	{	
		"7",
		"\127ff7070** Set target to friendly",
	},
	{	
		"8",
		"\127a168f1** Set target to hostile",
	}
}

T.Tab.navList = {}

T.Tab.colors = {
	"b07395",
	"d8808e",
	"ffa583",
	"ffc38c",
	"ffe5b1",
	"fff190",
	"ff7070",
	"a168f1",
	"7770ff",
	"3170ff",
}

T.Tab.autoTarget = false
T.Tab.distanceOnOffSwitch = false
T.Tab.targetMode = 1
T.Tab.targetTimer = Timer()
T.Tab.distanceTimer = Timer()
T.Tab.autoLoadCargo = false
T.Tab.autoUnloadCargo = false
T.Tab.saveLists = {}
T.Tab.systemnotes = 1120003471
T.Tab.systemnotesOld = 1120003472

local setRadarSelection = radar.SetRadarSelection
local pCommand = gkinterface.GKProcessCommand

	


-- tab change to Cargo, update list.. maybe useful later
function T.Tab:TARGETLIST_TAB_CHANGED()
	self.is_active = targetlist.API.IsActiveTab(T.Tab)
	if (self.is_active) then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes)) 
		T.Tab.cargoList = T.Tab.saveLists.cargoList
		T.Tab.dropsList = T.Tab.saveLists.dropsList
		T.Tab.navList = T.Tab.saveLists.navList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end



function T.Tab:ChangeFilter(index, page)
	T.Tab.filter_index = index
	T.Tab.filter_page = page
	T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
	T.Tab.cargoList = T.Tab.saveLists.cargoList
	T.Tab.dropsList = T.Tab.saveLists.dropsList
	T.Tab.navList = T.Tab.saveLists.navList
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.currentList = T.Tab.cargoList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.currentList = T.Tab.dropsList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 2 then
		T.Tab.currentList = T.Tab.featureList
		targetlist.API.UpdateDisplay(self, self.currentList)
	elseif self.filter_index == 3 then
		T.Tab.currentList = T.Tab.navList
		targetlist.API.UpdateDisplay(self, self.currentList)
	end
end


-- select target to find cargo 
function T.Tab:ChangeTarget(_, listEntryID)
	-- cargo finder
	if self.filter_index == 1 and self.filter_page == 1 then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local listEntryID = listEntryID
		local searchItem = " "
		-- search for silksteel
		if listEntryID == 1 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[1][3])
			searchItem = tableString

		-- search for nodules
		elseif listEntryID == 2 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[2][3])
			searchItem = tableString

		-- search for guardian cores
		elseif listEntryID == 3 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[3][3])
			searchItem = tableString

		-- search for dentek cores
		elseif listEntryID == 4 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[4][3])
			searchItem = tableString
			
		-- search for artemis cores
		elseif listEntryID == 5 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[5][3])
			searchItem = tableString

		-- search for Avalons
		elseif listEntryID == 6 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[6][3])
			searchItem = tableString

		-- search queen drops
		elseif listEntryID == 7 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[7][3])
			searchItem = tableString

		-- search observer optics
		elseif listEntryID == 8 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[8][3])
			searchItem = tableString

		--
		elseif listEntryID == 9 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[9][3])
			searchItem = tableString

		--
		elseif listEntryID == 10 then
			local tableString = filter_colorcodes(T.Tab.saveLists.cargoList[10][3])
			searchItem = tableString
		end

		local currentItem = " "
		local itemFound = 0
		-- start radar search at zero
		setRadarSelection(0,0)
		-- search through all items in range until something matches
		while (currentItem ~= nil and itemFound == 0) do
			pCommand("RadarNext");
			-- check found item 
			currentItem = GetTargetInfo()
			-- compare current item with the search item
			if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
				-- end the loop, cargo found
				itemFound = 1
			end
		end
		-- nothing found, still zero
		if itemFound == 0 then
			print("\127504aff** No cargo in range with: " .. "\127ff0000" .. searchItem .. "\127o")
		end

	-- second set of search items
	elseif self.filter_index == 1 and self.filter_page == 2 then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local listEntryID = listEntryID
		local searchItem = " "
		-- find lenb
		if listEntryID == 1 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[1][3])
			searchItem = tableString

		-- find ffsa
		elseif listEntryID == 2 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[2][3])
			searchItem = tableString

		-- find fcp 
		elseif listEntryID == 3 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[3][3])
			searchItem = tableString

		-- search rarified heliocene alloy
		elseif listEntryID == 4 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[4][3])
			searchItem = tableString

		-- find reinforced bulkheads
		elseif listEntryID == 5 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[5][3])
			searchItem = tableString

		-- find data aggy
		elseif listEntryID == 6 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[6][3])
			searchItem = tableString

		-- find samoflange
		elseif listEntryID == 7 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[7][3])
			searchItem = tableString

		--
		elseif listEntryID == 8 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[8][3])
			searchItem = tableString

		--
		elseif listEntryID == 9 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[9][3])
			searchItem = tableString

		--
		elseif listEntryID == 10 then
			local tableString = filter_colorcodes(T.Tab.saveLists.dropsList[10][3])
			searchItem = tableString
		end
		
		local currentItem = " "
		local itemFound = 0
		-- start radar search at zero
		setRadarSelection(0,0)
		-- search through all items in range until something matches
		while (currentItem ~= nil and itemFound == 0) do
			pCommand("RadarNext");
			-- check found item 
			currentItem = GetTargetInfo()
			-- compare current item with the search item
			if (currentItem ~= nil and string.find(string.lower(currentItem),string.lower(searchItem))) then
				-- end the loop, cargo found
				itemFound = 1
			end
		end
		-- nothing found, still zero
		if itemFound == 0 then
			print("\127504aff** No cargo in range with: " .. "\127ff0000" .. searchItem .. "\127o")
		end


	-- various tools
	elseif self.filter_index == 2 then
		local listEntryID = listEntryID
		-- autotarget on/off switch
		if listEntryID == 1 then
			if T.Tab.autoTarget == false then
				T.Tab.autoTarget = true
				RegisterEvent(T.Tab.playerDied, "PLAYER_DIED")
				print("\127a134eb** AutoTarget: ON\127o")
			elseif T.Tab.autoTarget == true then
				T.Tab.autoTarget = false
				T.Tab.distanceOnOffSwitch = false
				UnregisterEvent(T.Tab.playerDied, "PLAYER_DIED")
				print("\127a134eb** AutoTarget: OFF\127o")	
			end
		-- autotarget distance check
		elseif listEntryID == 2 then
			if T.Tab.distanceOnOffSwitch == false then
				-- set variable to true to turn the check on and meet if condition
				T.Tab.distanceOnOffSwitch = true;
				print("\127a134eb** AutoTarget: Distance check ON\127o");
				-- call the function, this time with a real function call
				T.Tab.checkDistance()
			elseif T.Tab.distanceOnOffSwitch == true then
				-- kill any remaining timers to prevent unforseen behavior
				if T.Tab.distanceTimer:IsActive() then T.Tab.distanceTimer:Kill() end
				-- set condition to false to interrupt the loop
				T.Tab.distanceOnOffSwitch = false
				print("\127a134eb** AutoTarget: Distance check OFF\127o");
			else
				T.Tab.distanceOnOffSwitch = false
				print("\127a134ebSomething went wrong. Disabling distance check.\127o")
			end
			
		-- post target to group
		elseif listEntryID == 3 then
			T.Tab.targetDetails("GROUP")

		-- post target to guild
		elseif listEntryID == 4 then
			T.Tab.targetDetails("GUILD")

		-- post target to active channel
		elseif listEntryID == 5 then
			T.Tab.targetDetails("CHANNEL")

		-- plot route to home station
		elseif listEntryID == 6 then
			local homeSectorID = GetHomeStation()
			local homeLocation = AbbrLocationStr(homeSectorID)
			NavRoute.SetFinalDestination(homeSectorID)
			print("\1277dd4ff** Navroute plotted to: " .. homeLocation .. "\127o")

		-- turn target friendly on radar
		elseif listEntryID == 7 then
			local delayTimer = Timer()
			local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
			local targetCharId = GetCharacterIDByName(targetName)
			local targetNodeID = GetPlayerNodeID(targetCharId)
			function GetFriendlyStatus(targetCharID)
				return 3
			end
    		delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)

		-- turn target hostile on radar
		elseif listEntryID == 8 then
			local delayTimer = Timer()
			local targetName, targetHealth, targetDistance, targetFactionid, targetGuild, targetShip = GetTargetInfo()
			local targetCharId = GetCharacterIDByName(targetName)
			local targetNodeID = GetPlayerNodeID(targetCharId)
			function GetFriendlyStatus(targetCharID)
				return 0
			end
    		delayTimer:SetTimeout(64, function() UpdateRadarFriendlyStatus(targetNodeID) end)

		-- autoload on/off
		elseif listEntryID == 9 then
			return
		-- autounload on/off
		elseif listEntryID == 10 then
			return
		end

	
	-- nav list
	elseif self.filter_index == 3 then
		T.Tab.saveLists = unspickle(LoadSystemNotes(T.Tab.systemnotes));
		local listEntryID = listEntryID
		-- plot to home
		if listEntryID == 1 then
			local homeSectorID = GetHomeStation()
			local homeLocation = AbbrLocationStr(homeSectorID)
			NavRoute.SetFinalDestination(homeSectorID)
			print("\1277dd4ff** Navroute plotted to: " .. homeLocation .. "\127o")
		
		-- plot to nyrius f-6
		elseif listEntryID == 2 then
			local sectorLocation = T.Tab.saveLists.navList[2][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

			-- plot to pel c12
		elseif listEntryID == 3 then
			local sectorLocation = T.Tab.saveLists.navList[3][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		-- plot to brac m14
		elseif listEntryID == 4 then
			local sectorLocation = T.Tab.saveLists.navList[4][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		-- plot to lat i8
		elseif listEntryID == 5 then
			local sectorLocation = T.Tab.saveLists.navList[5][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end
		
		-- plot to odia m-14
		elseif listEntryID == 6 then
			local sectorLocation = T.Tab.saveLists.navList[6][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		-- latos n-2
		elseif listEntryID == 7 then
			local sectorLocation = T.Tab.saveLists.navList[7][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		-- dau l-10
		elseif listEntryID == 8 then
			local sectorLocation = T.Tab.saveLists.navList[8][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		--
		elseif listEntryID == 9 then
			local sectorLocation = T.Tab.saveLists.navList[9][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		--
		elseif listEntryID == 10 then
			local sectorLocation = T.Tab.saveLists.navList[10][3] or ""
			local sectorID = SectorIDFromLocationStr(sectorLocation)
			if sectorLocation ~= "" then
				NavRoute.SetFinalDestination(sectorID)
				print("\1277dd4ff** Navroute plotted to: " .. sectorLocation .. "\127o")
			else
				print("\1277dd4ff** No navigation data, no route plotted.\127o")
			end

		end
	end
end




-- function to target nearest enemy once current target dies
function T.Tab.playerDied(event, victim, killer, weapon)
    -- assign all the event data to variables
    local owncharID = GetCharacterID()
    local ownName = GetPlayerName(owncharID)
    local victimName = GetPlayerName(victim)
    local killerName = GetPlayerName(killer)
    local usedWeapon = weapon
    local currentTarget = GetTargetInfo()
	-- if you still have a target, don't switch, someone else killed a bot
	if currentTarget ~= nil then
		return
	-- if you killed a bot, switch to nearest one
	elseif killerName == ownName then
		pCommand("RadarNextNearestEnemy")
	-- someone else killed your target, switch to nearest
	else
		pCommand("RadarNextNearestEnemy")
	end
    
end


-- distance check every 4 seconds, retarget nearest hostile 
function T.Tab.checkDistance()
	if T.Tab.autoTarget == true then
		if T.Tab.distanceOnOffSwitch == true then
			-- target nearest hostile
			pCommand("RadarNextNearestEnemy")
			-- re-allocate the timer because timers in vo are stupid af
			T.Tab.distanceTimer = Timer()
			-- recall the function after 4 seconds, function call needs to be a variable and not a function call because lua is dumb
			T.Tab.distanceTimer:SetTimeout(4000, T.Tab.checkDistance)
		end
	else
		print("\127a134eb** AutoTarget is OFF, distance check disabled.\127o")
	end
end



local floor = math.floor
local targetString = ""

-- send target to various chats
function T.Tab.targetDetails(channel)
    -- only fill in if there are target details
	if GetTargetInfo() ~= nil then
        -- fill in all the available stats
		local targetName, targetHealth, targetDistance, targetFactionID, targetGuild, targetShip = GetTargetInfo()
		local targetCharID = GetCharacterIDByName(targetName)
        -- if roids, only report name and distance
		if targetName == "Asteroid" or targetName == "Ice Crystal" then 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
        -- if it has health, it must be a player
        elseif targetHealth ~= nil then
            local factionInfo = FactionName[targetFactionID] or "";
            local guildTag = "[" .. targetGuild .. "]" or "";
            if targetGuild ~= "" then
                targetString = "Target: " .. guildTag .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .. " with ".. floor(targetHealth*100) .."% health at ".. floor(targetDistance) .. "m."  
            else
                targetString = "Target: " .. targetName .. " (" .. factionInfo .. "), (" .. targetCharID .. "), piloting " .. Article(targetShip) .." with " .. floor(targetHealth*100) .."% health at " .. floor(targetDistance) .. "m."
            end
		-- if it's neither roid or player, it must be cargo. separated for future additions
        else 
            targetString = "Target: " .. targetName .. " at " .. floor(targetDistance) .. "m."
		end
        -- send the actual targetString to channel 
        SendChat(targetString, channel:upper())
	end
end







-- check if plugin was loaded correctly
function T.Tab:PLUGINS_LOADED()
	if (isdeclared("targetlist") and targetlist.API) then
		if (targetlist.API.Version >= 1) then
			targetlist.API.RegisterTab(T.Tab)
		else
			print("\1277dd4ffMDI-TargetList API version is not compatible. Cargo Tab was not loaded.\127o")
		end
	end
end

-- check if targetlist is even installed
function T.Tab:PLAYER_ENTERED_GAME()
	if (not (isdeclared("targetlist") and targetlist.API)) then
		print("\1277dd4ffCargo Tab for MDI-TargetList requires version 4 or higher.\127o")
	end
end

dofile("settings.lua")

RegisterEvent(T.Tab, "TARGETLIST_TAB_CHANGED")
RegisterEvent(T.Tab, "PLUGINS_LOADED")
RegisterEvent(T.Tab, "PLAYER_ENTERED_GAME")

